//==========================================================================
// ļ: m45pe16.h
// : ST-M45PE16 2M Bytes Flash ⣬岿. 
// ΢: ATXmegaϵMCU
// ϵͳʱ: cMCUXTALûж壬ĬΪ29491200Hz
// Ȩ: XXX  аȨ
// ༭: UE13.0
// 뻷AVR studio 4.18 + WinAVR-20090313
// дʱ: 2010-07-29
// 汾: 1.0
// : XXX 
// ޸: 
// ޸: 
// ޸: 
//==========================================================================

//==========================================================================
// XMEGA ͳһ
// 1. Ϊ˳һԣЧXMEGAԴƶù
// 2. ˿ӳ£ӳϵҪڹǰʼ⺯вظãֱʹ
//    PA ---> VP0
//    PB ---> VP1
//    PC ---> VP2
//    PD ---> VP3 
//==========================================================================

#ifndef _atxmega_m45pe16_gcc_lib_h_
#define _atxmega_m45pe16_gcc_lib_h_   1

#include <avr/io.h>
#include "avr_type.h"
#include "../CRC16/CRC16.H"

//==========================================================================
// ʼϢʼ
// 1: ϵʼʱʼϢȷ USARTD1 ˿Ѿʼ 
// 0: ʼFlashʱʼϢ
//==========================================================================
#define M45PE16_INIT_INF_OUTPUT_EN  1

//==========================================================================
// ECC Уݱ
//==========================================================================
static const FINT8U ecc_column_table[] = {
	0x00, 0x55, 0x59, 0x0c, 0x65, 0x30, 0x3c, 0x69,
	0x69, 0x3c, 0x30, 0x65, 0x0c, 0x59, 0x55, 0x00,
	0x95, 0xc0, 0xcc, 0x99, 0xf0, 0xa5, 0xa9, 0xfc,
	0xfc, 0xa9, 0xa5, 0xf0, 0x99, 0xcc, 0xc0, 0x95,
	0x99, 0xcc, 0xc0, 0x95, 0xfc, 0xa9, 0xa5, 0xf0,
	0xf0, 0xa5, 0xa9, 0xfc, 0x95, 0xc0, 0xcc, 0x99,
	0x0c, 0x59, 0x55, 0x00, 0x69, 0x3c, 0x30, 0x65,
	0x65, 0x30, 0x3c, 0x69, 0x00, 0x55, 0x59, 0x0c,
	0xa5, 0xf0, 0xfc, 0xa9, 0xc0, 0x95, 0x99, 0xcc,
	0xcc, 0x99, 0x95, 0xc0, 0xa9, 0xfc, 0xf0, 0xa5,
	0x30, 0x65, 0x69, 0x3c, 0x55, 0x00, 0x0c, 0x59,
	0x59, 0x0c, 0x00, 0x55, 0x3c, 0x69, 0x65, 0x30,
	0x3c, 0x69, 0x65, 0x30, 0x59, 0x0c, 0x00, 0x55,
	0x55, 0x00, 0x0c, 0x59, 0x30, 0x65, 0x69, 0x3c,
	0xa9, 0xfc, 0xf0, 0xa5, 0xcc, 0x99, 0x95, 0xc0,
	0xc0, 0x95, 0x99, 0xcc, 0xa5, 0xf0, 0xfc, 0xa9,
	0xa9, 0xfc, 0xf0, 0xa5, 0xcc, 0x99, 0x95, 0xc0,
	0xc0, 0x95, 0x99, 0xcc, 0xa5, 0xf0, 0xfc, 0xa9,
	0x3c, 0x69, 0x65, 0x30, 0x59, 0x0c, 0x00, 0x55,
	0x55, 0x00, 0x0c, 0x59, 0x30, 0x65, 0x69, 0x3c,
	0x30, 0x65, 0x69, 0x3c, 0x55, 0x00, 0x0c, 0x59,
	0x59, 0x0c, 0x00, 0x55, 0x3c, 0x69, 0x65, 0x30,
	0xa5, 0xf0, 0xfc, 0xa9, 0xc0, 0x95, 0x99, 0xcc,
	0xcc, 0x99, 0x95, 0xc0, 0xa9, 0xfc, 0xf0, 0xa5,
	0x0c, 0x59, 0x55, 0x00, 0x69, 0x3c, 0x30, 0x65,
	0x65, 0x30, 0x3c, 0x69, 0x00, 0x55, 0x59, 0x0c,
	0x99, 0xcc, 0xc0, 0x95, 0xfc, 0xa9, 0xa5, 0xf0,
	0xf0, 0xa5, 0xa9, 0xfc, 0x95, 0xc0, 0xcc, 0x99,
	0x95, 0xc0, 0xcc, 0x99, 0xf0, 0xa5, 0xa9, 0xfc,
	0xfc, 0xa9, 0xa5, 0xf0, 0x99, 0xcc, 0xc0, 0x95,
	0x00, 0x55, 0x59, 0x0c, 0x65, 0x30, 0x3c, 0x69,
	0x69, 0x3c, 0x30, 0x65, 0x0c, 0x59, 0x55, 0x00,
};

//==========================================================================
// ECC  ־
//==========================================================================
#define ECC_NO_ERROR    0                                               // ûд
#define ECC_CORRECT_OK  1                                               // ɹ
#define ECC_DATA_ERROR  2                                               // ݴ


//==========================================================================
// M45PE16 ״̬
//==========================================================================
#define M45PE16_ERROR           0                                       // 
#define M45PE16_OK              1                                       // ɹ
#define M45PE16_MAX_PHY_PAGE    ((INT16U)8192)                          // ҳ 
#define M45PE16_MAX_LOGIC_PAGE  ((INT16U)(8192-256-256))                // һ 8192ҳ߼ַֻ(8192-256-32)ҳ256ҳӳ仵ҳ256ҳ
#define M45PE16_MAX_BAD_PAGE    ((INT8U)123)                            // ҳ 123ҳ
#define M45PE16_DATA_PAGE       (0x100)                                 // ʼҵַ
#define M45PE16_MAP_PAGE        (0x1F00)                                // 
#define M45PE16_PROGRESS        ((INT8U)(((8192-256)/50)+1))            // 

//==========================================================================
// M45PE16D 
//==========================================================================
#define M45PE16_WREN            ((INT8U)0x06)                           // д
#define M45PE16_WRDI            ((INT8U)0x04)                           // дֹ
#define M45PE16_RDID            ((INT8U)0x9F)                           // ID     0x20 40 15
#define M45PE16_RDSR            ((INT8U)0x05)                           // ״̬Ĵ
#define M45PE16_READ            ((INT8U)0x03)                           // ȡ     ʱС  33MHz
#define M45PE16_FAST_READ       ((INT8U)0x0B)                           // ٶȡ ʱӿԵ 50MHz
#define M45PE16_PW              ((INT8U)0x0A)                           // ҳд       ָ
#define M45PE16_PP              ((INT8U)0x02)                           // ҳ    1-->0
#define M45PE16_PE              ((INT8U)0xDB)                           // ҳ    0-->1
#define M45PE16_SE              ((INT8U)0xD8)                           //   0-->1
#define M45PE16_DP              ((INT8U)0xB9)                           // ȵ
#define M45PE16_RDP             ((INT8U)0xAB)                           // ͷȵ

//==========================================================================
// IO 
//==========================================================================
#define M45PE16_SI_DIR          PORTA_DIR                               // M45PE16_SI = PA3
#define M45PE16_SI_DIRS         PORTA_DIRSET                            // 
#define M45PE16_SI_DIRC         PORTA_DIRCLR                            // 
#define M45PE16_SI_OUT          PORTA_OUT                               // 
#define M45PE16_SI_OUTS         PORTA_OUTSET                            // 
#define M45PE16_SI_OUTC         PORTA_OUTCLR                            // 
#define M45PE16_SI_IN           PORTA_IN                                // 
#define M45PE16_SI_CTRL         PORTA_PIN3CTRL                          // 
#define M45PE16_SI              3                                       // 
                                                                        
#define M45PE16_SO_DIR          PORTA_DIR                               // M45PE16_SO = PA4
#define M45PE16_SO_DIRS         PORTA_DIRSET                            // 
#define M45PE16_SO_DIRC         PORTA_DIRCLR                            // 
#define M45PE16_SO_OUT          PORTA_OUT                               // 
#define M45PE16_SO_OUTS         PORTA_OUTSET                            // 
#define M45PE16_SO_OUTC         PORTA_OUTCLR                            // 
#define M45PE16_SO_IN           PORTA_IN                                // 
#define M45PE16_SO_CTRL         PORTA_PIN4CTRL                          // 
#define M45PE16_SO              4                                       // 
                                                                        
#define M45PE16_SCK_DIR         PORTA_DIR                               // M45PE16_SCK = PA5
#define M45PE16_SCK_DIRS        PORTA_DIRSET                            // 
#define M45PE16_SCK_DIRC        PORTA_DIRCLR                            // 
#define M45PE16_SCK_OUT         PORTA_OUT                               // 
#define M45PE16_SCK_OUTS        PORTA_OUTSET                            // 
#define M45PE16_SCK_OUTC        PORTA_OUTCLR                            // 
#define M45PE16_SCK_IN          PORTA_IN                                // 
#define M45PE16_SCK_CTRL        PORTA_PIN5CTRL                          // 
#define M45PE16_SCK             5                                       // 
                                                                        
#define M45PE16_CS_DIR          PORTA_DIR                               // M45PE16_CS = PA6
#define M45PE16_CS_DIRS         PORTA_DIRSET                            // 
#define M45PE16_CS_DIRC         PORTA_DIRCLR                            // 
#define M45PE16_CS_OUT          PORTA_OUT                               // 
#define M45PE16_CS_OUTS         PORTA_OUTSET                            // 
#define M45PE16_CS_OUTC         PORTA_OUTCLR                            // 
#define M45PE16_CS_IN           PORTA_IN                                // 
#define M45PE16_CS_CTRL         PORTA_PIN6CTRL                          // 
#define M45PE16_CS              6                                       // 
                                                                        
#define M45PE16_WP_DIR          PORTA_DIR                               // M45PE16_WP = PA7
#define M45PE16_WP_DIRS         PORTA_DIRSET                            // 
#define M45PE16_WP_DIRC         PORTA_DIRCLR                            // 
#define M45PE16_WP_OUT          PORTA_OUT                               // 
#define M45PE16_WP_OUTS         PORTA_OUTSET                            // 
#define M45PE16_WP_OUTC         PORTA_OUTCLR                            // 
#define M45PE16_WP_IN           PORTA_IN                                // 
#define M45PE16_WP_CTRL         PORTA_PIN7CTRL                          // 
#define M45PE16_WP              7                                       // 


//==========================================================================
// IO 
//==========================================================================
#define M45PE16_SI_OUTPUT_1()   do {                                    \
    M45PE16_SI_CTRL |= 0x80;                                            \
    M45PE16_SI_OUTS  = (1<<M45PE16_SI);                                 \
    M45PE16_SI_DIRS  = (1<<M45PE16_SI);                                 \
}while(0)

#define M45PE16_SI_OUTPUT_0()   do {                                    \
    M45PE16_SI_CTRL |= 0x80;                                            \
    M45PE16_SI_OUTC  = (1<<M45PE16_SI);                                 \
    M45PE16_SI_DIRS  = (1<<M45PE16_SI);                                 \
}while(0)

#define M45PE16_SCK_OUTPUT_1()  do {                                    \
    M45PE16_SCK_CTRL|= 0x80;                                            \
    M45PE16_SCK_OUTS = (1<<M45PE16_SCK);                                \
    M45PE16_SCK_DIRS = (1<<M45PE16_SCK);                                \
}while(0)

#define M45PE16_SCK_OUTPUT_0()  do {                                    \
    M45PE16_SCK_CTRL|= 0x80;                                            \
    M45PE16_SCK_OUTC = (1<<M45PE16_SCK);                                \
    M45PE16_SCK_DIRS = (1<<M45PE16_SCK);                                \
}while(0)

#define M45PE16_CS_OUTPUT_1()   do {                                    \
    M45PE16_CS_CTRL |= 0x80;                                            \
    M45PE16_CS_OUTS  = (1<<M45PE16_CS);                                 \
    M45PE16_CS_DIRS  = (1<<M45PE16_CS);                                 \
    asm volatile("NOP");                                                \
    asm volatile("NOP");                                                \
    asm volatile("NOP");                                                \
    asm volatile("NOP");                                                \
}while(0)

#define M45PE16_CS_OUTPUT_0()   do {                                    \
    M45PE16_CS_CTRL |= 0x80;                                            \
    M45PE16_CS_OUTC  = (1<<M45PE16_CS);                                 \
    M45PE16_CS_DIRS  = (1<<M45PE16_CS);                                 \
    asm volatile("NOP");                                                \
    asm volatile("NOP");                                                \
    asm volatile("NOP");                                                \
    asm volatile("NOP");                                                \
}while(0)

#define M45PE16_WP_OUTPUT_1()   do {                                    \
    M45PE16_WP_CTRL |= 0x80;                                            \
    M45PE16_WP_OUTS  = (1<<M45PE16_WP);                                 \
    M45PE16_WP_DIRS  = (1<<M45PE16_WP);                                 \
}while(0)

#define M45PE16_WP_OUTPUT_0()   do {                                    \
    M45PE16_WP_CTRL |= 0x80;                                            \
    M45PE16_WP_OUTC  = (1<<M45PE16_WP);                                 \
    M45PE16_WP_DIRS  = (1<<M45PE16_WP);                                 \
}while(0)

#define M45PE16_SO_INPUT_PH()   do {                                    \
    M45PE16_SO_CTRL |= 0x18;                                            \
    M45PE16_SO_DIRC  = (1<<M45PE16_SO);                                 \
}while(0)

#define M45PE16_SO_INPUT       ( M45PE16_SO_IN & (1<<M45PE16_SO) )


//==========================================================================
// Ʊ
// ע⣬ڲƱϽⲿֱ
//==========================================================================
INT8U   m45pe16_init_flag = M45PE16_ERROR;                              // ʼ־ûгʼֹдflash
INT8U   m45pe16_buff[256];                                              // 
INT8U   m45pe16_bad_page_num;                                           // ҳĿ
INT8U   m45pe16_bad_page_addr[256];                                     // 


//==========================================================================
// ڲԭ
//==========================================================================
void    sub_m45pe16_send_8bit_data(  INT8U  data );                     //  Flash д 8bits 
INT8U   sub_m45pe16_read_8bit_data(  void );                            //  Flash  8bits 
void    sub_m45pe16_write_enable( void );                               // д Flash 
void    sub_m45pe16_write_disable( void );                              // д Flash ֹ
INT32U  sub_m45pe16_read_id( void );                                    //  Flash ID
INT8U   sub_m45pe16_read_state( void );                                 //  Flash ״̬Ĵ

INT8U   sub_m45pe16_read_phy_page(  INT16U page, INT8U data[256] );     // ȡһҳݣʹҳַʹ READ òȴ
INT8U   sub_m45pe16_erase_phy_page( INT16U page );                      // ҳʹҳַ 10ms
INT8U   sub_m45pe16_prog_phy_page(  INT16U page, INT8U data[256] );     // Ѳҳʹҳַ 0.8ms
INT8U   sub_m45pe16_write_phy_page( INT16U page, INT8U data[256] );     // дһҳݣ̹̣ ʹҳַ11ms

INT8U   sub_m45pe16_check_page( INT16U phy_page );
INT16U  sub_m45pe16_logic_addr_to_phy_addr( INT16U logic_addr );
void    sub_m45pe16_ecc_calculate(const INT8U data[256], INT8U ecc[3]);
INT8U   sub_m45pe16_ecc_correct(INT8U data[256], INT8U read_ecc[3], INT8U cal_ecc[3]);
INT8U   sub_m45pe16_ecc_count_bits( INT8U data );

#if     M45PE16_INIT_INF_OUTPUT_EN == 1                                 // Ϣ廵ҳϢ
void    sub_m45pe16_bad_pages_inf( void );                              // 
void    sub_m45pe16_init_progress( INT8U progress );                    // 
#endif                                                                  // 


//==========================================================================
// ⲿԭ
//==========================================================================
void    sub_m45pe16_init( void );
INT32U  sub_m45pe16_read_id( void ); 
INT8U   sub_m45pe16_erase_page( INT16U logic_page ); 
INT8U   sub_m45pe16_read_page(  INT16U logic_page, INT8U buff[256] ); 
INT8U   sub_m45pe16_write_page( INT16U logic_page, INT8U buff[256] ); 

#endif 


